<?php
/**
 * Clase Base DP para BasePlaEmpresaColaboradorLogDP
 *
 * @package    
 * @subpackage BasePlaEmpresaColaboradorLogDP
 * @author     Willy
 * @version    SVN:: BasePlaEmpresaColaboradorLogDP.class.php,v 1.1 2022-07-23 14:30:20 william.taype Exp $
 */
abstract class BasePlaEmpresaColaboradorLogDP extends PlaEmpresaColaboradorLogBN
{
  /* Número de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof PlaEmpresaColaboradorLogBN )
    {
      $o_PlaEmpresaColaboradorLogBN = $bSetDefault;
      if($o_PlaEmpresaColaboradorLogBN->getIdEmpresaColLog()) : $this->setIdEmpresaColLog($o_PlaEmpresaColaboradorLogBN->getIdEmpresaColLog()); endif;
      if($o_PlaEmpresaColaboradorLogBN->getIdEmpresa()) : $this->setIdEmpresa($o_PlaEmpresaColaboradorLogBN->getIdEmpresa()); endif;
      if($o_PlaEmpresaColaboradorLogBN->getIdColaborador()) : $this->setIdColaborador($o_PlaEmpresaColaboradorLogBN->getIdColaborador()); endif;
      if($o_PlaEmpresaColaboradorLogBN->getFechaCreacion()) : $this->setFechaCreacion($o_PlaEmpresaColaboradorLogBN->getFechaCreacion()); endif;
      if($o_PlaEmpresaColaboradorLogBN->getUsuarioCreacion()) : $this->setUsuarioCreacion($o_PlaEmpresaColaboradorLogBN->getUsuarioCreacion()); endif;
      if($o_PlaEmpresaColaboradorLogBN->getFechaRegistro()) : $this->setFechaRegistro($o_PlaEmpresaColaboradorLogBN->getFechaRegistro()); endif;
      if($o_PlaEmpresaColaboradorLogBN->getUsuarioRegistro()) : $this->setUsuarioRegistro($o_PlaEmpresaColaboradorLogBN->getUsuarioRegistro()); endif;
    }
  }

  /* Obtiene el número de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(IdEmpresaColLog),(MAX(IdEmpresaColLog)+1), 1) AS Maximo FROM pla_empresa_colaborador_log;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdEmpresaColLog($row[0]);

      if($this->getIdEmpresaColLog()){
        $a_Fields = array();

        if($this->getIdEmpresaColLog()) : $a_Fields['IdEmpresaColLog'] = ($this->getIdEmpresaColLog()); endif;
        if($this->getIdEmpresa()) : $a_Fields['IdEmpresa'] = ($this->getIdEmpresa()); endif;
        if($this->getIdColaborador()) : $a_Fields['IdColaborador'] = ($this->getIdColaborador()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;
        if($this->getFechaRegistro()) : $a_Fields['FechaRegistro'] = ($this->getFechaRegistro()); endif;
        if($this->getUsuarioRegistro()) : $a_Fields['UsuarioRegistro'] = ($this->getUsuarioRegistro()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO pla_empresa_colaborador_log (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdEmpresaColLog())
      {
        $a_Fields = array();

        if($this->getIdEmpresaColLog()) : $a_Fields['IdEmpresaColLog'] = ($this->getIdEmpresaColLog()); endif;
        if($this->getIdEmpresa()) : $a_Fields['IdEmpresa'] = ($this->getIdEmpresa()); endif;
        if($this->getIdColaborador()) : $a_Fields['IdColaborador'] = ($this->getIdColaborador()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;
        if($this->getFechaRegistro()) : $a_Fields['FechaRegistro'] = ($this->getFechaRegistro()); endif;
        if($this->getUsuarioRegistro()) : $a_Fields['UsuarioRegistro'] = ($this->getUsuarioRegistro()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE pla_empresa_colaborador_log SET ".$sStringField." WHERE 1 AND IdEmpresaColLog='".$this->getIdEmpresaColLog()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdEmpresaColLog())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM pla_empresa_colaborador_log WHERE 1 AND IdEmpresaColLog='".$this->getIdEmpresaColLog()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* Búsqueda del registro por la llave primaria */
  public static function selectByPK($vIdEmpresaColLog)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdEmpresaColLog, IdEmpresa, IdColaborador, FechaCreacion, UsuarioCreacion, FechaRegistro, UsuarioRegistro FROM pla_empresa_colaborador_log WHERE 1 AND IdEmpresaColLog='".$vIdEmpresaColLog."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_PlaEmpresaColaboradorLogDP = new PlaEmpresaColaboradorLogDP();
    $o_PlaEmpresaColaboradorLogDP->setIdEmpresaColLog($o_propel->IdEmpresaColLog);
    $o_PlaEmpresaColaboradorLogDP->setIdEmpresa($o_propel->IdEmpresa);
    $o_PlaEmpresaColaboradorLogDP->setIdColaborador($o_propel->IdColaborador);
    $o_PlaEmpresaColaboradorLogDP->setFechaCreacion($o_propel->FechaCreacion);
    $o_PlaEmpresaColaboradorLogDP->setUsuarioCreacion($o_propel->UsuarioCreacion);
    $o_PlaEmpresaColaboradorLogDP->setFechaRegistro($o_propel->FechaRegistro);
    $o_PlaEmpresaColaboradorLogDP->setUsuarioRegistro($o_propel->UsuarioRegistro);
    return $o_PlaEmpresaColaboradorLogDP;
  }
}